C 
C *** Wave Simulaion using Amplification Factor of Layered Structure
c    iVϐk\́FēcAXkoŁ@pp.231-233j
C
      PROGRAM mwave2
C
C INPUT DATA  
C ** FOM    : FIRST CIRCULAR FREQUENCY ( OMEGA )
C ** DOM    : INCREMENT OF CIRCULAR FREQUENCY ( DELTA OMEGA )
C ** NOM    : TOTAL NUMBER OF CIRCULAR FREQUENCY
C ** MOM    : NOM IN MAIN PROGRAM DIMENSION
C ** DNS(I) : DENSITY OF Ith LAYER
C ** VS (I) : VS OF Ith LAYER
C ** THK(I) : THICKNESS OF Ith LAYER
C ** VE (I) : VE=sqrt(E/dns) OF Ith LAYER (E: Young Coefficient)
C ** NL     : TOTAL NUMBER OF LAYERS
C ** ML     : NL IN MAIN PROGRAM DIMENSION
C ** THETA  : INCIDENT ANGLE OF SH WAVE ( RADIAN )
C OUTPUT DATA  
C ** AMP(I,1) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the input wave
C ** AMP(I,2) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the bedrock motion
C ** SPCA(I): SPECTRUM AMPLITUDE OF AMP(I)
C
      PARAMETER(ML=50,MOM=8200)
      DIMENSION DNS(ML),VP(ML),QP(ML),VS(ML),QS(ML),THK(ML)
      COMPLEX AMP(MOM,2),FX1(mom),delay
      CHARACTER INFILE1*20
      REAL TIME(mom),XR1(mom),XI1(mom)
C
      WRITE(*,*)
c      WRITE(*,*)' : Soil Data must be "soiln_dat"'
C
C  Prompt for wave file
C
      WRITE(*,1010) 
 1010 FORMAT(/1X,'Enter Acceleration Data (H1,H2,V1)')
      READ(*,1020) INFILE1
 1020 FORMAT(A20)
C
      OPEN(11,FILE=INFILE1,status='old')
        i=1
   10   read(11,*,end=11)time(i),xr1(i)
c        write(*,*)time(i),xr1(i)
        i=i+1
        goto 10
   11 CLOSE(11)
c
      NT=i-1
      dt=time(2)-time(1)
      write(*,*)'NT and DT=',NT,DT
c
C *** Find the Closest Number of 2**N ***
C
      NF=2
      do I=2,15
        NF=2*NF
        IF(NF.GE.NT)GOTO 30
      end do
      WRITE(*,*)' NT>2**15 !!!!!'
      STOP
   30 IF1=I
      WRITE(*,*)
      WRITE(*,*)' IF1,NF=',IF1,NF
c
C *** FOURIER TRANSFORM of the Original Wave ***
C
      do I=1,NT
        FX1(I)=CMPLX(xr1(I),0.0)
      end do
      do I=NT+1,NF
        FX1(I)=(0.0,0.0)
      end do
C
      CALL WVFAST(NF,FX1,mm,-1)
      DUR=dFLOAT(NF)*DT
      DOM=6.283185307/DUR
      NOM=NF/2+1
      EOM=DOM*NOM
      WRITE(*,*)
      WRITE(*,*)' DUR,DOM,NOM,EOM=',DUR,DOM,NOM,EOM
      WRITE(*,*)' Highest Frequency (hz)=',EOM/6.2831853070d0
      do I=1,NF
        FX1(I)=FX1(I)*DT
      end do
c
c *** Calculation of Amplification Factor ***
c
      fom=0.0
      ndata=nom
      CALL SOILIN(DNS,VP,QP,VS,QS,THK,PQF,NL,ML,THETA,NSF)

      write(*,*)'  Enter Horizontal(=0), Vertical(=1) or Vp(=2):'
	read(*,*)ihv  
	if(ihv.eq.0)then
        CALL SBSHML(FOM,DOM,NOM,MOM,DNS,VS,QS,THK
     *             ,PQF,NL,ML,THETA,NSF,AMP)
	else 
	  if(ihv.eq.1)then
          CALL SBUDML(FOM,DOM,NOM,MOM,DNS,VP,QP,VS,QS,THK
     *               ,PQF,NL,ML,THETA,NSF,AMP)
	  else
          CALL SBSHML(FOM,DOM,NOM,MOM,DNS,VP,QP,THK
     *               ,PQF,NL,ML,THETA,NSF,AMP)
	  end if
	end if
      write(*,*)
      write(*,*)'S_amp: Amplification Factor for S wave'
      write(*,*)
      write(*,*)'WAVE * AMP(i):' 
      write(*,*)'  Enter 1 for AMP with respect to INPUT WAVE:'
      write(*,*)'  Enter 2 for AMP with respect to BEDROCK WAVE:'
	read(*,*)is  
	  
c
      open(9,file='S_amp1',status='unknown')
      do i=1,ndata
        om=dom*(i-1)
        fq=om/6.2831853
        write(9,1140)fq,amp(i,1),cabs(amp(i,1)),amp(i,2),cabs(amp(i,2))
        delay=(1.0,0.0)
        do l=1,nl-1
          delay=delay*cexp(cmplx(0.0,om*thk(l)/vs(l)))
        end do
        fx1(i)=fx1(i)*amp(i,is)*delay
        xr1(i)=real(fx1(i))
        xi1(i)=aimag(fx1(i))
      end do
      close(9)
 1140 format(f8.4,6e12.4)
C     
C * DIFFERENTIATION *
C
      WRITE(*,*)
      WRITE(*,*)
     * ' You can integrate or differentiate the original wave.;'
      WRITE(*,*)
     * '   Do not change   (Enter -> 0),'
      WRITE(*,*)
     * '   Integrate       (Enter -> 1),'
      WRITE(*,*)
     * '   Differentiate   (Enter -> 2):'
      READ(*,*)NYES
C     
C * BAND PASS *
C
      WRITE(*,*)
      WRITE(*,*)' Band Pass Filter? (Yes=1 or No=0) :'
      READ(*,*)NBD
C
      OML1=0.0
      OMH2=99999.9
      IF(NBD.EQ.1)THEN
        WRITE(*,*)'   Data for TRAPEZOIDAL BAND PASS FILTER:'
        WRITE(*,*)'   INITIAL AND FINAL OMs =',0,DOM*(NDATA-1)
        WRITE(*,*)
        WRITE(*,*)
     *  '   Enter OML1,OML2,OMH1 and OMH2 (OML1<OML2<OMH1<OMH2): '
        READ(*,*)OML1,OML2,OMH1,OMH2
      END IF
C
C * Write data to a complex array *
C
      FX1(1) = CMPLX(0.0,0.0)
      DO 200 I = 2,NDATA
           OMEGA=FLOAT(I-1)*DOM
           AA=1.0
           IF(NBD.EQ.1)THEN
             IF((OMEGA.LE.OML1).or.(OMEGA.GE.OMH2))then
	       aa=0.0
             else
               IF(OMEGA.LT.OML2)AA=(OMEGA-OML1)/(OML2-OML1)
               IF(OMEGA.GT.OMH1)AA=(OMH2-OMEGA)/(OMH2-OMH1)
	     end if
           end if
    	   FX1(I) = AA*CMPLX(XR1(I),XI1(I))

           IF(NYES.EQ.1)THEN
             FX1(I)=FX1(I)/(OMEGA*CMPLX(0.0,1.0))
           END IF
           IF(NYES.EQ.2)THEN
             FX1(I)=FX1(I)*OMEGA*CMPLX(0.0,1.0)
           END IF
  200 CONTINUE
c
c * Output Fourier Spectrum data *
c
      write(*,*)
      write(*,*)'The Fourier Spectrum data are stored in "amp_dat"'
      open(10,file='amp_dat',status='unknown')
      DO 250 I = 2,NDATA
        OMEGA=FLOAT(I-1)*DOM
        freq=omega/6.283185307
        write(10,1500)freq,FX1(I),cabs(FX1(I))
  250 CONTINUE
 1500 format(f8.4,6e12.4)
      close(10)
C
C * INVERSE FOURIER TRANSFORM  *
C
      DO 400 I=2,NF/2
           FX1(NF+2-I)=CMPLX(REAL(FX1(I)),-AIMAG(FX1(I)))
  400 CONTINUE
C
      CALL WVFAST(NF,FX1,MOM,1)
C
C * WAVE DATA *
C
      DO 450 I = 1,NF
         TIME(I) = FLOAT(I-1)*DT
         XR1(I)=REAL(FX1(I))/DUR
  450 CONTINUE
C
C * MAX AND MIN AMPLITUDE *
C
      XMAX=0.0 
      XMIN=0.0 
C
      DO 550 I=1,NF
        IF(XR1(I).GT.XMAX)XMAX=XR1(I)
        IF(XR1(I).LT.XMIN)XMIN=XR1(I)
  550 CONTINUE
C
      AMAX=XMAX
      AMIN=XMIN
C
      WRITE(*,*)
      WRITE(*,*)' Nmber of data points    =',NF
      WRITE(*,*)' Duration and Delta Time =',DUR,DT
      WRITE(*,*)' Initial and final times =',0.0,DUR-DT
      WRITE(*,*)
      WRITE(*,*)' Min and Max amplitudes  =',AMIN,AMAX
C      
C * Output data file  *
C
      WRITE(*,*)
      WRITE(*,*)'Output data are stored in "mwave_dat"'
      WRITE(*,*)
      OPEN(11,FILE='mwave_dat',STATUS='unknown')
c      WRITE(11,*)NF,DT,AMIN,AMAX
      do i=1,NT
      write(11,2000)TIME(I),XR1(I)
      end do
      CLOSE(11)
 2000 FORMAT(F8.3,3E12.4)
c
      STOP
      END
C
C *** FOURIER TRANSFORM OR INVERSE FOURIER TRANSFORM
C
      SUBROUTINE WVFAST(N,A,MOM,IND)
C
C * N   : NUMBER OF FOURIER COEFF. OR WAVE POINTS (=2**I)
C * A(I): FOURIER COEFFICIENTS ( N/2+1 ) OR WAVE DATA (REAL PART)
C    ( FOURIER SPECTRUM = FOURIER COEFFICIENTS * DURATION/2.0 )
C * MOM : N IN MAIN DIMMENSION
C * IND : = -1 : TRANS.,   = 1 : INVERSE TRANS.
C
      COMPLEX A(MOM),TEMP,THETA
C
C * FFT and inverse FFT *
C
      PAI=3.1415926540e0
      J=1
      DO 140 I=1,N
        IF(I.GE.J) GO TO 110
        TEMP=A(J)
        A(J)=A(I)
        A(I)=TEMP
  110   M=N/2
  120   IF(J.LE.M) GO TO 130
        J=J-M
        M=M/2
        IF(M.GE.2) GO TO 120
  130   J=J+M
  140 CONTINUE
      KMAX=1
  150 IF(KMAX.GE.N) RETURN
      ISTEP=KMAX*2
      DO 170 K=1,KMAX
        THETA=CMPLX(0.0,PAI*FLOAT(IND*(K-1))/FLOAT(KMAX))
        DO 160 I=K,N,ISTEP
          J=I+KMAX
          TEMP=A(J)*CEXP(THETA)
          A(J)=A(I)-TEMP
          A(I)=A(I)+TEMP
  160   CONTINUE
  170 CONTINUE
      KMAX=ISTEP
      GO TO 150
C
      END
c
C
C *** READ OF SOIL DATA FROM DATA FILE
C 
      SUBROUTINE SOILIN(DNS,VP,QP,VS,QS,THK,PQF,NL,ML,THETA,NSF)
C
C ** THETA  : INCIDENT ANGLE OF SH WAVE ( DEGREE --> RADIAN )
C ** NSF    : =1:OUTPUT POINT IS ON SURFACE, =0:OUTPUT POINT IS IN SOIL
C
      DIMENSION DNS(ML),vp(ml),qp(ml),VS(ML),qs(ML),thk(ml)
      CHARACTER FNAME*30
C
C *** SOIL DATA INPUT ***
C 
      WRITE(*,10)
   10 FORMAT(/' Enter Soil Data File Name ')
   11 READ(*,'(A)')FNAME
      IF(FNAME(1:1).EQ.' ')GOTO 11

      OPEN(4,FILE=FNAME,STATUS='OLD')
      READ(4,1010)THET1
      READ(4,1020)NSF
      READ(4,1030)NL,PQF
      DO 100 IL=1,NL
      READ(4,1040)DNS(IL),VP(IL),QP(IL),VS(IL),QS(IL),THK(IL)
  100 CONTINUE
 1010 FORMAT(F10.0)
 1020 FORMAT(I10)
 1030 FORMAT(I10,F10.0)
 1040 FORMAT(6f8.0)
C
C *** CHANGE THETA FROM DEGREE TO RADIAN ***
C
      THETA=THET1*0.017453292520e0
c
      RETURN
      END
c
C
C *** CUL. OF AMPLITUDE FACTER BY MULTIPLE REFLECTION METHOD OF SH WAVE
c    iVϐk\́FēcAXkoŁ@pp.231-233j
C 
      SUBROUTINE SBSHML(FOM,DOM,NOM,MOM,DNS,VS,QS,THK,PQF
     *                 ,NL,ML,THETA,NSF,AMP)
C
C INPUT DATA  
C ** FOM    : FIRST CIRCULAR FREQUENCY ( OMEGA )
C ** DOM    : INCREMENT OF CIRCULAR FREQUENCY ( DELTA OMEGA )
C ** NOM    : TOTAL NUMBER OF CIRCULAR FREQUENCY
C ** MOM    : NOM IN MAIN PROGRAM DIMENSION
C ** DNS(I) : DENSITY OF Ith LAYER
C ** VS (I) : VS OF Ith LAYER
C ** THK(I) : THICKNESS OF Ith LAYER
C ** QS(I)  : QUALITY FACTER OF Ith LAYER
C ** PQF    : Q=Qs*(freq)**PQF
C ** NL     : TOTAL NUMBER OF LAYERS
C ** ML     : NL IN MAIN PROGRAM DIMENSION
C ** THETA  : INCIDENT ANGLE OF SH WAVE ( RADIAN )
C ** NSF    : = 1:OUTPUT POINT IS ON SURFACE,  = 0:IN SOIL
C OUTPUT DATA  
C ** AMP(I,1) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the input wave
C ** AMP(I,2) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the bedrock motion
C
      DIMENSION DNS(ML),THK(ML),VS(ML),QS(ML)
      COMPLEX*8 AMP(MOM,2),VSN2,CINV2,A11,A12,A21,A22,VS1,VS2,VS21,VS22
     *      ,am,ex1,ex2,WN,WND,SA11,SA12,SA21,SA22,SB11,SB12,SB21,SB22
C
C *** CAL. OF AMPLITUDE FACTER ***
C
      VSN2=CMPLX(VS(NL)*VS(NL),0.0)
      TSIN=SIN(THETA)
      CINV2=TSIN*TSIN/VSN2
C
      SF=1.0
      IF(NSF.EQ.1)SF=2.0
C
      IFOM=1
      IF(FOM.EQ.0.0)THEN
      AMP(1,1)=CMPLX(SF,0.0)
      AMP(1,2)=CMPLX(1.0,0.0)
      IFOM=2
      END IF
C
      DO 200 IO=IFOM,NOM
C
        OM=FLOAT(IO-1)*DOM+FOM
        freq=om/6.2831853
C
        A11=(1.0,0.0)
        A12=(0.0,0.0)
        A21=(0.0,0.0)
        A22=(1.0,0.0)
C
        DO 100 IL=NL-1,1,-1
C
          SA11=A11
          SA12=A12
          SA21=A21
          SA22=A22
C
          VS1=VS(IL)
          VS2=VS(IL+1)
          IF(PQF.ne.999.0)then
            Q=QS(IL)*(freq)**PQF
            VS1=VS1*CMPLX(1.0,0.5/Q)
            Q=QS(IL+1)*(freq)**PQF
            VS2=VS2*CMPLX(1.0,0.5/Q)
          end if
          am=dns(IL)*vs1/(dns(IL+1)*vs2)
          vs21=VS1*VS1
          vs22=VS2*VS2
          WN=OM*CSQRT(1.0/VS21-CINV2)
          WND=WN*THK(IL)*cmplx(0.0,1.0)
          ex1=cexp(+WND)
          ex2=cexp(-WND)
C
           SB11=(1.0+am)*ex1/2.0
           SB12=(1.0-am)*ex2/2.0
           SB21=(1.0-am)*ex1/2.0
           SB22=(1.0+am)*ex2/2.0
C
          A11=SA11*SB11+SA12*SB21
          A12=SA11*SB12+SA12*SB22
          A21=SA21*SB11+SA22*SB21
          A22=SA21*SB12+SA22*SB22
C
  100   CONTINUE
C
        AMP(IO,1)=SF/(A11+A12)
        AMP(IO,2)=2.0/(A11+A12+A21+A22)
c	write(*,*)'om,amp2',om,AMP(IO,2)
c	if(io.eq.20)stop
C
  200 CONTINUE
C
      RETURN
      END
c
C
C *** CUL. OF AMPLITUDE FACTER BY MULTIPLE REFLECTION METHOD OF UD WAVE
c    iVϐk\́FēcAXkoŁ@pp.231-233j
C 
      SUBROUTINE SBUDML(FOM,DOM,NOM,MOM,DNS,VP,QP,VS,QS,THK,PQF
     *                 ,NL,ML,THETA,NSF,AMP)
C
C INPUT DATA  
C ** FOM    : FIRST CIRCULAR FREQUENCY ( OMEGA )
C ** DOM    : INCREMENT OF CIRCULAR FREQUENCY ( DELTA OMEGA )
C ** NOM    : TOTAL NUMBER OF CIRCULAR FREQUENCY
C ** MOM    : NOM IN MAIN PROGRAM DIMENSION
C ** DNS(I) : DENSITY OF Ith LAYER
C ** VS (I) : VS OF Ith LAYER
C ** THK(I) : THICKNESS OF Ith LAYER
C ** QS(I)  : QUALITY FACTER OF Ith LAYER
C ** PQF    : Q=Qs*(freq)**PQF
C ** NL     : TOTAL NUMBER OF LAYERS
C ** ML     : NL IN MAIN PROGRAM DIMENSION
C ** THETA  : INCIDENT ANGLE OF SH WAVE ( RADIAN )
C ** NSF    : = 1:OUTPUT POINT IS ON SURFACE,  = 0:IN SOIL
C OUTPUT DATA  
C ** AMP(I,1) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the input wave
C ** AMP(I,2) : AMPLITUDE FACTER ON SURFACE at Ith OMEGA, withe respect to the bedrock motion
C
      DIMENSION DNS(ML),THK(ML),VP(ML),QP(ML),VS(ML),QS(ML)
      COMPLEX*8 AMP(MOM,2),VSN2,CINV2,A11,A12,A21,A22,VS1,VS2,VP1,VP2
     *       ,am,ex1,ex2,WN,WND,SA11,SA12,SA21,SA22,SB11,SB12,SB21,SB22
     *       ,aa,vsp1,vsp2,vv2
C
C *** CAL. OF AMPLITUDE FACTER ***
C
      aa=3.0/(1.0-VS(NL)*VS(NL)/(VP(NL)*VP(NL)))
      VSN2=CMPLX(VS(NL)*VS(NL),0.0)*aa
c	write(1,*)'NL,VSP=',NL,csqrt(VSN2)
      TSIN=SIN(THETA)
      CINV2=TSIN*TSIN/VSN2
C
      SF=1.0
      IF(NSF.EQ.1)SF=2.0
C
      IFOM=1
      IF(FOM.EQ.0.0)THEN
      AMP(1,1)=CMPLX(SF,0.0)
      AMP(1,2)=CMPLX(1.0,0.0)
      IFOM=2
      END IF
C
      DO 200 IO=IFOM,NOM
C
        OM=FLOAT(IO-1)*DOM+FOM
        freq=om/6.2831853
C
        A11=(1.0,0.0)
        A12=(0.0,0.0)
        A21=(0.0,0.0)
        A22=(1.0,0.0)
C
        DO 100 IL=NL-1,1,-1
C
          SA11=A11
          SA12=A12
          SA21=A21
          SA22=A22
C
          VS1=VS(IL)
          VS2=VS(IL+1)
          VP1=VP(IL)
          VP2=VP(IL+1)
          IF(PQF.ne.999.0)then
            QFQ=(freq)**PQF
            Q=QS(IL)*QFQ
            VS1=VS1*CMPLX(1.0,0.5/Q)
c      write(1,*)'freq,Q,VS1',freq,Q,VS1
            Q=QP(IL)*QFQ
            VP1=VP1*CMPLX(1.0,0.5/Q)
c      write(1,*)'freq,Q,VP1',freq,Q,VP1
            Q=QS(IL+1)*QFQ
            VS2=VS2*CMPLX(1.0,0.5/Q)
c      write(1,*)'freq,Q,VS2',freq,Q,VS2
            Q=QP(IL+1)*QFQ
            VP2=VP2*CMPLX(1.0,0.5/Q)
c      write(1,*)'freq,Q,VP2',freq,Q,VP2
          end if
          aa=csqrt(3.0/(1.0-VS1*VS1/(VP1*VP1)))
          vsp1=VS1*aa
          aa=csqrt(3.0/(1.0-VS2*VS2/(VP2*VP2)))
          vsp2=VS2*aa
c	write(1,*)'IL+1,VSP=',IL+1,vsp2
c	write(1,*)'IL,  VSP=',IL,vsp1
c	if(IL.eq.12)stop

          am=dns(IL)*vsp1/(dns(IL+1)*vsp2)
          vv2=vsp1*vsp1
          WN=OM*CSQRT(1.0/vv2-CINV2)
          WND=WN*THK(IL)*cmplx(0.0,1.0)
          ex1=cexp(+WND)
          ex2=cexp(-WND)
C
           SB11=(1.0+am)*ex1/2.0
           SB12=(1.0-am)*ex2/2.0
           SB21=(1.0-am)*ex1/2.0
           SB22=(1.0+am)*ex2/2.0
C
          A11=SA11*SB11+SA12*SB21
          A12=SA11*SB12+SA12*SB22
          A21=SA21*SB11+SA22*SB21
          A22=SA21*SB12+SA22*SB22
C
  100   CONTINUE
C
        AMP(IO,1)=SF/(A11+A12)
        AMP(IO,2)=2.0/(A11+A12+A21+A22)
C
  200 CONTINUE
C
      RETURN
      END
